"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AppNotificationUI = void 0;
var react_1 = __importDefault(require("react"));
var react_native_1 = require("react-native");
var styled_1 = require("./styled");
exports.AppNotificationUI = function (_a) {
    var title = _a.title, message = _a.message, imageUrl = _a.imageUrl, onPress = _a.onPress, panEnabled = _a.panEnabled, containerStyle = _a.containerStyle, imageStyle = _a.imageStyle, messageStyle = _a.messageStyle, titleStyle = _a.titleStyle, left = _a.left, right = _a.right;
    return (react_1.default.createElement(styled_1.Card, { style: containerStyle, activeOpacity: onPress || panEnabled ? 0.7 : 1, onPress: onPress },
        react_1.default.createElement(react_native_1.View, { style: { alignItems: 'center', justifyContent: 'center', flexDirection: 'row' } },
            left && react_1.default.createElement(styled_1.LeftContainer, null, left),
            imageUrl && react_1.default.createElement(styled_1.BaseImage, { source: { uri: imageUrl }, style: imageStyle }),
            react_1.default.createElement(styled_1.TextContainer, null,
                title && react_1.default.createElement(styled_1.Title, { style: [{ marginBottom: 4 }, titleStyle] }, title),
                react_1.default.createElement(styled_1.Message, { style: messageStyle }, message)),
            right && react_1.default.createElement(styled_1.RightContainer, null, right))));
};
exports.default = exports.AppNotificationUI;
