"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FadeOut = exports.FadeIn = exports.Shrink = exports.SlideUpFadeIn = exports.DEFAULT_DURATION = void 0;
var react_1 = __importStar(require("react"));
var react_native_1 = require("react-native");
var useAnimatedValue_1 = __importDefault(require("../hooks/useAnimatedValue"));
exports.DEFAULT_DURATION = 200;
var DEFAULT_Y_OFFSET = -48;
exports.SlideUpFadeIn = function (_a) {
    var children = _a.children, _b = _a.delay, delay = _b === void 0 ? 0 : _b, _c = _a.duration, duration = _c === void 0 ? exports.DEFAULT_DURATION : _c, _d = _a.yOffset, yOffset = _d === void 0 ? DEFAULT_Y_OFFSET : _d, reversed = _a.reversed;
    var opacity = useAnimatedValue_1.default(0);
    var translateY = useAnimatedValue_1.default(reversed ? -yOffset : yOffset);
    react_1.useEffect(function () {
        react_native_1.Animated.parallel([
            react_native_1.Animated.timing(opacity, {
                toValue: 1,
                duration: duration,
                delay: delay,
                useNativeDriver: true,
            }),
            react_native_1.Animated.timing(translateY, {
                toValue: 0,
                duration: duration,
                delay: delay,
                useNativeDriver: true,
            }),
        ]).start();
    }, []);
    return (react_1.default.createElement(react_native_1.Animated.View, { style: {
            opacity: opacity,
            transform: [{ translateY: translateY }],
        } }, children));
};
exports.Shrink = function (_a) {
    var children = _a.children, _b = _a.delay, delay = _b === void 0 ? 0 : _b, _c = _a.duration, duration = _c === void 0 ? exports.DEFAULT_DURATION : _c, initialHeight = _a.height;
    var scale = useAnimatedValue_1.default(1);
    var height = useAnimatedValue_1.default(initialHeight);
    react_1.useEffect(function () {
        react_native_1.Animated.parallel([
            react_native_1.Animated.timing(scale, {
                toValue: 0,
                duration: duration,
                delay: delay,
                useNativeDriver: true,
            }),
            react_native_1.Animated.timing(height, {
                toValue: 0,
                duration: duration,
                delay: delay,
                useNativeDriver: false,
            }),
        ]).start();
    }, []);
    return (react_1.default.createElement(react_native_1.Animated.View, { style: { height: height } },
        react_1.default.createElement(react_native_1.Animated.View, { style: {
                transform: [{ scale: scale }],
            } }, children)));
};
exports.FadeIn = function (_a) {
    var children = _a.children, _b = _a.delay, delay = _b === void 0 ? 0 : _b, _c = _a.duration, duration = _c === void 0 ? exports.DEFAULT_DURATION : _c;
    var opacity = useAnimatedValue_1.default(0);
    react_1.useEffect(function () {
        react_native_1.Animated.timing(opacity, {
            toValue: 1,
            duration: duration,
            delay: delay,
            useNativeDriver: true,
        }).start();
    }, []);
    return (react_1.default.createElement(react_native_1.Animated.View, null,
        react_1.default.createElement(react_native_1.Animated.View, { style: {
                opacity: opacity,
            } }, children)));
};
exports.FadeOut = function (_a) {
    var children = _a.children, _b = _a.delay, delay = _b === void 0 ? 0 : _b, _c = _a.duration, duration = _c === void 0 ? exports.DEFAULT_DURATION : _c;
    var opacity = useAnimatedValue_1.default(1);
    react_1.useEffect(function () {
        react_native_1.Animated.timing(opacity, {
            toValue: 0,
            duration: duration,
            delay: delay,
            useNativeDriver: true,
        }).start();
    }, []);
    return (react_1.default.createElement(react_native_1.Animated.View, null,
        react_1.default.createElement(react_native_1.Animated.View, { style: {
                opacity: opacity,
            } }, children)));
};
