"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AppNotificationWrapper = void 0;
var react_1 = __importStar(require("react"));
var react_native_1 = require("react-native");
var useAnimatedValue_1 = __importDefault(require("../hooks/useAnimatedValue"));
var useLayout_1 = __importDefault(require("../hooks/useLayout"));
var animations_1 = require("./animations");
exports.AppNotificationWrapper = function (_a) {
    var animateOut = _a.animateOut, _b = _a.animated, animated = _b === void 0 ? true : _b, _c = _a.panEnabled, panEnabled = _c === void 0 ? true : _c, onPress = _a.onPress, alignBottom = _a.alignBottom, children = _a.children, _d = _a.animationWrappers, animationWrappers = _d === void 0 ? { in: undefined, out: undefined } : _d;
    var _e = react_1.useState(false), hide = _e[0], setHide = _e[1];
    var _f = useLayout_1.default(), layout = _f[0], bindLayout = _f[1];
    var translateX = useAnimatedValue_1.default(0);
    var pan = react_1.useRef(react_native_1.PanResponder.create({
        onMoveShouldSetPanResponderCapture: function () { return true; },
        onPanResponderMove: function (e, _a) {
            var dx = _a.dx;
            translateX.setValue(dx);
        },
        onPanResponderStart: function (e, _a) { },
        onPanResponderRelease: function (e, _a) {
            var vx = _a.vx, dx = _a.dx;
            var screenWidth = react_native_1.Dimensions.get('window').width;
            if (Math.abs(dx) < 0.1 * screenWidth)
                onPress === null || onPress === void 0 ? void 0 : onPress();
            if (Math.abs(vx) >= 0.5 || Math.abs(dx) >= 0.5 * screenWidth) {
                react_native_1.Animated.timing(translateX, {
                    toValue: dx > 0 ? screenWidth : -screenWidth,
                    duration: 200,
                    useNativeDriver: true,
                }).start(function () { return setHide(true); });
            }
            else {
                react_native_1.Animated.spring(translateX, {
                    toValue: 0,
                    bounciness: 10,
                    useNativeDriver: true,
                }).start();
            }
        },
    })).current;
    var PanWrapper = react_native_1.Animated.View;
    var panWrapperProps = {};
    var AnimationWrapper = react_native_1.View;
    var wrapperProps = {};
    if (animated) {
        if (panEnabled) {
            PanWrapper = react_native_1.Animated.View;
            panWrapperProps = __assign(__assign({}, pan.panHandlers), { style: { opacity: +!hide, transform: [{ translateX: translateX }] } });
        }
        var outAnimation = animationWrappers.out || animations_1.Shrink;
        var inAnimation = animationWrappers.in || animations_1.SlideUpFadeIn;
        AnimationWrapper = animateOut ? outAnimation : inAnimation;
        wrapperProps.height = layout.height;
        if (hide) {
            AnimationWrapper = animations_1.Shrink;
        }
        if (alignBottom && !animateOut) {
            wrapperProps.reversed = true;
        }
    }
    return (react_1.default.createElement(AnimationWrapper, __assign({}, wrapperProps),
        react_1.default.createElement(PanWrapper, __assign({}, panWrapperProps),
            react_1.default.createElement(react_native_1.View, __assign({}, bindLayout), children))));
};
exports.default = exports.AppNotificationWrapper;
